<!-- =========================================================================================
  File Name: DashboardAnalytics.vue
  Description: Dashboard Analytics
========================================================================================== -->

<template>
  <div id="dashboard-analytics">
    <vs-tabs v-if="statisticData" alignment="center">
      <vs-tab label="Tổng quan">
        <OverviewStatisticsTabView
          :info="displayData.overview"
          :style="
            `${
              wasSidebarOpen ? 'margin-right: 100px; margin-left: 100px;' : ''
            }`
          "
        />
        <div class="no-sth" />
      </vs-tab>
      <vs-tab label="Công việc">
        <ul class="demo-alignment mb-5">
          <li
            class="ml-0 mr-2"
            :key="index"
            v-for="(el, index) in ['week', 'month', 'year']"
          >
            <vs-button :color="periodColor(el)" @click="periodTabIndex = el">{{
              period_tabs[el].label
            }}</vs-button>
          </li>
        </ul>
        <PeriodStatisticsTabView
          :selectedTab="period_tabs[periodTabIndex]"
          :tabs="period_tabs"
          :chartData="displayData[periodTabIndex]"
        />
        <div class="no-sth" />
      </vs-tab>
    </vs-tabs>
  </div>
</template>

<script>
import PeriodStatisticsTabView from "../presentations/general-analytic/PeriodStatisticsTabView";
import OverviewStatisticsTabView from "../presentations/general-analytic/OverviewStatisticsTabView";
// import dummyData from "../presentations/general-analytic/dummyData";
import { round10, toPercent } from "../core/utils/math";
import { todoLabelColor } from "../core/utils/color";
import { HabitDayOfWeekEnums } from "../constants/enums";

export default {
  components: { PeriodStatisticsTabView, OverviewStatisticsTabView },

  data() {
    return {
      period_tabs: {
        week: { idex: 1, label: "Tuần", id: "week" },
        month: { idex: 2, label: "Tháng", id: "month" },
        year: { idex: 3, label: "Năm", id: "year" }
      },
      periodTabIndex: "week",
      // Config layout
      wasSidebarOpen: null
    };
  },

  watch: {
    "$store.state.reduceButton"(val) {
      this.wasSidebarOpen = val;
    }
  },

  computed: {
    periodColor() {
      return el =>
        this.periodTabIndex == el ? "primary" : "rgb(185, 179, 248)";
    },
    statisticData() {
      // console.log(
      //   "[GENERAL_ANALYTIC] data =",
      //   this.$store.getters["todo/queriedStatisticData"]
      // );
      return this.$store.getters["todo/queriedStatisticData"];
    },

    projectList() {
      return this.$store.state.todo.taskProjects;
    },

    displayData() {
      const calcProductive = (inTime, total) => (inTime / total) * 100;

      const statisticData = this.statisticData;
      const all = statisticData.allTask;
      const today = statisticData.taskToday;
      const week = statisticData.taskWeek;
      const month = statisticData.taskMonth;
      const year = statisticData.taskYear;
      const lastWeek = statisticData.taskLastWeek;
      const lastMonth = statisticData.taskLastMonth;
      const lastYear = statisticData.taskLastYear;
      console.log("lastYear =", lastYear);
      const completedLast7Days = statisticData.completedLast7Days;

      return {
        overview: {
          // Tổng quan
          general: {
            totalTasks: all.totalTasks,
            completedTasks: all.totalCompletedTasks,
            totalProjects: this.projectList.length,
            productiveVsLastWeek: (
              calcProductive(week.taskInTime, week.totalCompletedTasks) -
              calcProductive(lastWeek.taskInTime, lastWeek.totalCompletedTasks)
            ).toFixed(1)
          },
          overview: {
            todayCompletedTasks: today.totalCompletedTasks,
            totalCompletedTasks: all.totalCompletedTasks,
            todayOnTime: today.taskInTime,
            todayOverdue: today.taskLate,
            todayUndated: today.taskFinished,
            todayUncompleted: today.totalUncompletedTasks
          },
          // Hoàn thành 7 ngày gần đây
          completedLast7Days: {
            series: completedLast7Days.series,
            categories: completedLast7Days.categories.map(
              item => HabitDayOfWeekEnums[item]
            )
            // chartColors: to do something
          },
          ...this.buildChartData(all)
        },
        today: {
          ...this.buildChartData(today)
        },
        week: {
          ...this.buildChartData(week, lastWeek)
        },
        month: {
          ...this.buildChartData(month, lastMonth)
        },
        year: {
          ...this.buildChartData(year, lastYear)
        }
      };
    }
  },

  created() {
    // Fetch Habits
    this.$store.dispatch("todo/fetchStatisticData", {});

    // Fetch Task
    // this.$store.dispatch("todo/fetchTasks", {});

    // Fetch Project
    this.$store.dispatch("todo/fetchProjects");
  },

  methods: {
    buildChartData(item, last) {
      const percent = (value, total) => round10(toPercent(value, total));
      return {
        // Số lượng task hoàn thành
        completedTasks: {
          current: item.totalCompletedTasks,
          last: last
            ? item.totalCompletedTasks - last.totalCompletedTasks
            : null
        },
        // Tỷ lệ task hoàn thành
        completedRate: {
          current: percent(item.totalCompletedTasks, item.totalTasks),
          last: last
            ? percent(item.totalCompletedTasks, item.totalTasks) -
              percent(last.totalCompletedTasks, last.totalTasks)
            : null
        },
        // Năng suất hoàn thành
        completionRateDistribution: this.buildCompletionRateDistributionData({
          totalUncompletedTasks: item.totalUncompletedTasks,
          taskFinished: item.taskFinished,
          taskInTime: item.taskInTime,
          taskLate: item.taskLate,
          totalCompletedTasks: item.totalCompletedTasks,
          totalTasks: item.totalTasks
        }),
        // Hoàn thành theo phân loại
        classifiedCompletionStatistics: this.buildClassifiedCompletionStatisticsData(
          {
            projectStatistic: item.projectStatistic,
            labelStatistic: item.labelStatistic,
            totalCompletedTasks: item.totalCompletedTasks,
            totalTasks: item.totalTasks
          }
        )
      };
    },
    buildClassifiedCompletionStatisticsData({
      projectStatistic,
      labelStatistic,
      totalCompletedTasks,
      totalTasks
    }) {
      const percent = (value, total) => round10(toPercent(value, total));
      const top4Ranking = list =>
        list.sort((a, b) => (a.tasks < b.tasks ? 1 : -1)).slice(0, 4);
      return {
        data: projectStatistic || [],
        byList: {
          completedTasks: totalCompletedTasks,
          columns: projectStatistic.map(item => ({
            name: item.projectName,
            color: todoLabelColor(item.projectColor || "charcoal").color,
            tasks: item.completedTasksCount
          })),
          // [
          //   { name: "Inbox", color: "rgb(184, 37, 95)", tasks: 4 },
          //   { name: "Health ❤️", color: "rgb(175, 184, 59)", tasks: 1 }
          // ]
          categoryRanking: {
            columns: top4Ranking(
              projectStatistic.map(item => ({
                name: item.projectName,
                color: todoLabelColor(item.projectColor || "charcoal").color,
                tasks: item.completedTasksCount,
                percent: percent(item.completedTasksCount, totalTasks)
              }))
            )
            // [
            //   { name: "Vacation Prep 🌴", tasks: 10, percent: 100 },
            //   { name: "Health ❤️", tasks: 9, percent: 90 },
            //   { name: "Learning Jappanese ⏰", tasks: 9, percent: 90 },
            //   { name: "House 😁", tasks: 8, percent: 80 }
            // ]
          }
        },
        byTag: {
          completedTasks: totalTasks,
          columns: labelStatistic.map(item => ({
            name: item.labelName,
            color: todoLabelColor(item.labelColor || "charcoal").color,
            tasks: item.completedTasksCount
          })),
          categoryRanking: {
            columns: top4Ranking(
              labelStatistic.map(item => ({
                name: item.labelName,
                color: todoLabelColor(item.labelColor || "charcoal").color,
                tasks: item.completedTasksCount,
                percent: percent(item.completedTasksCount, totalTasks)
              }))
            )
          }
        }
      };
    },
    buildCompletionRateDistributionData({
      totalUncompletedTasks,
      taskFinished,
      taskInTime,
      taskLate,
      totalCompletedTasks,
      totalTasks
    }) {
      const percent = (value, total) => round10(toPercent(value, total));
      return {
        // totalTasks: all.totalTasks,
        // totalUncompletedTasks: all.totalUncompletedTasks, // taskNotFinished + taskNoDueDate
        // taskNotFinished: all.taskNotFinished, // !isCompleted && dueDate
        // taskNoDueDate: all.taskNoDueDate, // !isCompleted && !dueDate
        // taskFinished: all.taskFinished, // isCompleted && !dueDate
        // taskInTime: all.taskInTime,
        // taskLate: all.taskLate
        completionRate: percent(totalCompletedTasks, totalTasks),
        columns: [
          {
            name: "overdue",
            tasks: taskLate,
            percent: percent(taskLate, totalTasks)
          },
          {
            name: "onTime",
            tasks: taskInTime,
            percent: percent(taskInTime, totalTasks)
          },
          {
            name: "undated",
            tasks: taskFinished,
            percent: percent(taskFinished, totalTasks)
          },
          {
            name: "uncompleted",
            tasks: totalUncompletedTasks,
            percent: percent(totalUncompletedTasks, totalTasks)
          }
        ]
      };
    }
  },

  mounted() {
    this.wasSidebarOpen = this.$store.state.reduceButton;
    this.$store.commit("TOGGLE_REDUCE_BUTTON", true);
  },

  beforeDestroy() {
    if (!this.wasSidebarOpen) this.$store.commit("TOGGLE_REDUCE_BUTTON", false);
  }
};
</script>
